title display progress on 640*480*16 logo screen - code

;

a_proc          display_logo
                pusha

                  mov si,Offset string0
                  mov dx,0
                  call display_string

                  mov si,Offset string1_blank
                  mov dx,1
                  call display_string

                  mov si,Offset string2_blank
                  mov dx,2
                  call display_string

                popa
                ret
a_endp          display_logo

;

a_proc          display_completed
                pusha

                  mov si,Offset string2
                  mov dx,2
                  call display_string

                popa
                ret
a_endp          display_completed

;
a_proc          ax_hex
                pusha

                  mov ch,0
                  shl cl,2              ; *4
                  ror ax,cl
                  shr cl,2              ; /4
  @@loop:
                  rol ax,4
                  push ax
                    and al,00fh
                    cmp al,10
                    sbb al,69h
                    das
                    mov [si],al
                    inc si
                  pop ax
                  loop @@loop

                popa
                ret
a_endp          ax_hex
;
; bx=bus/device/function
; di=register
a_proc          display_pci_use
                pusha

                  mov si,Offset str1_dev
                  mov ax,bx
                  mov cx,4
                  call ax_hex

                  mov si,Offset str1_reg
                  mov ax,di
                  mov cx,2
                  call ax_hex

                  mov si,Offset string1
                  mov dx,1
                  call display_string

                popa
                ret
a_endp          display_pci_use

;
; eax=source address
; es:di=target
; cx=length (divisible by 4)
a_proc          CopyRealModeMemory
                pushad
                push ds

IFDEF OS2
                  mov bx,ax
                  shr eax,(32-4)
                 ;mov cx,cx
                  mov dh,0            ; result to ds:si
                  mov dl,DevHlp_PhysToVirt
                  call DeviceHelp
                  jc @@exit
ELSE
                  push eax
                  pop si
                  pop ds
ENDIF

                  shr cx,2
                  cld
                  rep movsd
  @@exit:
                pop ds
                popad
                ret
a_endp          CopyRealModeMemory

;

DataPacketGETVIDEOFONTS Struc
  Font8x14      dd ?
  Font8x8Low    dd ?
  Font8x8High   dd ?
  Font9x14      dd ?
  Font8x16      dd ?
  Font9x16      dd ?
DataPacketGETVIDEOFONTS EndS

p_proc          copy_font8x8

                Local @@Font8x8Low      :DWord
                Local @@Font8x8High     :DWord
IFDEF OS2
                Local @@RequestPacket   :RequestBlock_10
                Local @@DataPacket      :DataPacketGETVIDEOFONTS
ENDIF ; OS2

                push ds
                push es
                pushad

IFDEF DOS
                  ; patch this to test it in DOS (force graphics mode)
                  mov ax,00012h
                 ;int 010h
                  nop
                  nop
ENDIF ; DOS


                  mov @@Font8x8Low ,0f000fa6eh
                  mov @@Font8x8High,0f000fa6eh

                  ; on IBM and compatibles, there would be an 8x8 system BIOS font at F000h:FA6Eh
                  ; this does not work on ThinlPad T42 however..
                  ; solution: ask int $10/ax=1130 bh=3/4 or OEMHLP$
IFDEF OS2
                  mov bx,Offset drivername_OEMHLP
                  mov di,Offset attach_table
                  mov dl,DevHlp_AttachDD
                  call DeviceHelp
                  jc @@use_fixed_address

                  mov eax,DWord Ptr attach_table.IDC_IP_ring0
                  mov OEMHLP_IDC,eax
                  mov ax,attach_table.IDC_DS_ring0
                  mov OEMHLP_DS,ax

                  mov @@RequestPacket.Length_of_Packet,Size RequestBlock_10
                  mov @@RequestPacket.Block_Device_Unit_Code,0
                  mov @@RequestPacket.Command_Code,CMDGenIOCTL
                  and @@RequestPacket.Request_Packet_Status,0
                  and @@RequestPacket.Reserved,0
                  and @@RequestPacket.Queue_Linkage,0
                  mov @@RequestPacket.RGI_Function_Category,080h        ; IOCTL_OEMHLP
                  mov @@RequestPacket.RGI_Function_Code,003h            ; OEMHLP_GETVIDEOFONTS
                  mov @@RequestPacket.RGI_Parameter_Buffer.offs,0
                  mov @@RequestPacket.RGI_Parameter_Buffer.sel ,0
                  lea ax,@@DataPacket
                  mov @@RequestPacket.RGI_Data_Buffer.offs,ax
                  mov @@RequestPacket.RGI_Data_Buffer.sel ,ss
                  mov @@RequestPacket.RGI_System_File_Num,0
                  mov @@RequestPacket.RGI_Parameter_Len,0
                  mov @@RequestPacket.RGI_Data_Len,Size DataPacketGETVIDEOFONTS
                  push ds
                  push es
                  push fs
                  push gs
                  pushad

                    push ss
                    pop es
                    lea bx,@@RequestPacket
                    push Seg OEMHLP_IDC
                    pop gs
                    mov ds,gs:[OEMHLP_DS]
                    call gs:[OEMHLP_IDC]

                  popad
                  pop gs
                  pop fs
                  pop es
                  pop ds

                  cmp @@RequestPacket.Request_Packet_Status,0100h
                  jne @@use_fixed_address

                  mov eax,@@DataPacket.Font8x8Low
                  mov @@Font8x8Low,eax
                  mov eax,@@DataPacket.Font8x8High
                  mov @@Font8x8High,eax

  @@use_fixed_address:

ELSE ; DOS
                  mov ax,01130
                  mov bh,3
                  push bp
                    int 010h
                    mov bx,bp
                  pop bp
                  mov @@Font8x8Low.offs,si
                  mov @@Font8x8Low.sel ,es

                  mov ax,01130
                  mov bh,4
                  push bp
                    int 010h
                    mov si,bp
                  pop bp
                  mov @@Font8x8High.offs,si
                  mov @@Font8x8High.sel ,es
ENDIF ; DOS


                  push ds
                  pop es

                  mov cx,128*8

                  mov di,Offset font8x8
                  mov eax,@@Font8x8Low
                  call CopyRealModeMemory

                  add di,cx
                  mov eax,@@Font8x8High
                  call CopyRealModeMemory
  @@exit:

                popad
                pop es
                pop ds
                ret
p_endp          copy_font8x8

;

; ds:si=string
; dx=line, zero based
a_proc          display_string
                push es
                pusha

IFDEF screen_output_disabled
                  cmp [screen_output_disabled],true
                  je @@exit
ENDIF ; screen_output_disabled


IFDEF OS2
                  push dx
                    ; A000:0000
                    mov ax,0000ah
                    sub bx,bx
                    mov cx,(640/8)*480
                    mov dh,1            ; result to es:di
                    mov dl,DevHlp_PhysToVirt
                    call DeviceHelp
                  pop dx
                  jc @@exit
ELSE ; DOS
                  push 00040h
                  pop es
                  cmp Byte Ptr es:[00049h],012h
                  jne @@exit

                  push 0a000h
                  pop es
                  sub di,di

ENDIF ; DOS
                  imul dx,dx,(640/8*8)
                  add di,dx

                  mov cx,80
  @@loop_80:
                  mov al,[si]
                  inc si
                  cmp al,0
                  jne @@not_end_of_string

                  mov al,' '
                  dec si

  @@not_end_of_string:

                  pusha
                    movzx si,al
                    shl si,3                    ; *8
                    mov cx,8
  @@one_char:
                    mov al,font8x8[si]
                    inc si
                    mov es:[di],al
                    add di,80
                    loop @@one_char
                  popa

                  add di,1
                  loop @@loop_80

  @@exit:

                popa
                pop es
                ret
display_string  EndP

;
